/*%
 *  TITULO:	DOS test for FixPoint
 *  ARCHIVO:
 *
 *  VERSION:	SVC 0.0.0
 *
 *  CONTENIDO:
 *
 *  AUTORES:	Daniel Bacher
 *  FECHA:
 *  REFERENCIA:
 *
 *		Copyright (c) 1994-1995 Soluciones Verticales Consultores
 *		All rights reserved.
%*/
#include <stdio.h>
#include "fixpoint.h"
#include <assert.h>

int main ()
{
    FixPoint Zero;
    long double TestValue = (long double) LOMAX + 9876543.21;
    FixPoint One (TestValue);
    assert (Zero < One);
    assert (One <= One);
    assert (One >= One);
    FixPoint Two (2 * TestValue);
    assert (Two == One + One);
    assert (One < Two);
    assert (Two > One);
    FixPoint Three = Two + One;
    assert (Three != One);
    FixPoint Four = Two + Two;
    FixPoint Five = Two + Two + Two - One;
    FixPoint MinusOne = Four - Five;
    assert (MinusOne < Zero);
    assert (Zero == One + MinusOne);
    FixPoint MinusTwo = MinusOne + MinusOne;
    FixPoint MinusThree = MinusTwo - One;
    assert (MinusThree == Zero - Three);
    assert (MinusThree + Two == MinusOne);
    assert (MinusThree + Four == One);
    FixPoint Seven = Five + Two;
    FixPoint Six = Seven + MinusOne;
    assert (Six == Four + Two);
    FixPoint Eight = Two + Six;
    assert (Eight == Five + Three);
    assert (Four + Four == Six + Two);
    Six = Four;
    Six += Two;
    assert (Six == Five + One);
    assert (Four == Eight - Four);

    char buffer [128];

    One.ToString (buffer, sizeof (buffer));
    printf ("One == %s\n", buffer);
    FixPoint OtherOne (buffer);
    assert (One == OtherOne);
    MinusOne.ToString (buffer, sizeof (buffer));
    printf ("MinusOne == %s\n", buffer);
    FixPoint OtherMinusOne (buffer);
    assert (MinusOne == OtherMinusOne);
    return 0;
}
